package N
import N._
import scala.concurrent.duration._
import io.gatling.core.Predef._
import io.gatling.http.Predef._
import io.gatling.jdbc.Predef._
import io.gatling.http.request._
import io.gatling.core.structure.ChainBuilder
import io.gatling.http.request.builder.HttpRequestBuilder
//import io.gatling.http.request.builder.HttpRequestWithParamsBuilder
import scala.collection.mutable.ArrayBuffer
import scala.collection.mutable.ListBuffer
import io.gatling.core.session.Expression
import io.gatling.core.session._
import io.gatling.core.session.el._
import io.gatling.commons.validation._
//import scala.collection.mutable.Map
import scala.util.control.Breaks._
import scala.util.Random


object funRenderEHub{
	var time = System.currentTimeMillis()
	val funRenderEHubContents = group("${aScriptReferencePrefix}_${NetworkType}_005_EHUB_HubLoad_RenderContents")
							{
								exec(http("/")
									.get("/")
									.disableFollowRedirect
								.check(status.in(200,302)))
								.exec(http("Eweb")
									.get("/dashboard/web/Eweb")
								.check(regex("""Login""")))
								.exec(http("ESystemServiceUpdates/getStatus")
									.get("/dashboard/o/ESystemServiceUpdates/getStatus")
									.resources(http("getUserPopups")
										.get("XXXXXXXX?_=" + time))	//1616173095998
								.check(status.is(200)))
							}
							.exec(addCookie(Cookie("XXX_SESSION_STATE_XXXX", System.currentTimeMillis().toString)))	
	
}

object funEPortalLogOn{	

	var GArrBuff = ArrayBuffer[String]()
			var LongNameArrBuff = ArrayBuffer[String]()
			var TemplateArrBuff = ArrayBuffer[String]()
			var DelegateArrBuff = ArrayBuffer[String]()
			var pGPortletID = ""
			var sPortletLongName = ""
			var pEditedPortletLongName = ""
			var sPortletTemplate = ""
			var sPortletDelegateURL1 = ""
			var time = System.currentTimeMillis()
			var req = ListBuffer[String]()
			var req1 = ListBuffer[String]()
			var Psize = 0
	 
	 val headers_5 = Map(
		"Accept" -> "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9",
		"Sec-Fetch-Dest" -> "document",
		"Sec-Fetch-Mode" -> "navigate",
		"Sec-Fetch-Site" -> "same-origin",
		"Sec-Fetch-User" -> "?1",
		"Upgrade-Insecure-Requests" -> "1")
		
	val funEPortalLogOn =  group("${aScriptReferencePrefix}_${NetworkType}_0010_NavigateToEPortalLogIn"){	
								group("${aScriptReferencePrefix}_${NetworkType}_0010_P001_NavigateToEPortalLogIn_Primary"){
								exec(http("NavigateToEPortalLogIn_Primary")
									.get("/dashboard/c/portal/login?nav=myE")
									.headers(headers_5)
									.disableFollowRedirect
									.check(status.is(302))
									.check(headerRegex("location", GlobalVariableConstants.baseUrl+"(.*)").find.saveAs("dynActionURL_PortalLogOn_1")))
								}
								.group("${aScriptReferencePrefix}_${NetworkType}_0010_R002_NavigateToEPortalLogIn_Redirection"){
								exec(http("NavigateToEPortalLogIn_Redirection")
									.get("${dynActionURL_PortalLogOn_1}")
									.headers(headers_5)
									//.check(status.is(200))
									.check(regex("""Log in with your credentials""").find))
								}
								
							}
							.exec(session => {
								val rs = session("NetworkType").as[String]
								val N3url = "XXXXXX"
								val W3url = "XXXXXXX"
								//println("rsDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDd: "+rs)
								if(rs=="N3")
									session.set("dynActionURL_PortalLogOn_2", N3url)
								else
									session.set("dynActionURL_PortalLogOn_2", W3url)
								//println("SESSSSSIIONNN" + session)
								//session
							})
							
							.pause("${minThinkTime}", "${maxThinkTime}")
							
							
							
							.group("${aScriptReferencePrefix}_${NetworkType}_0020_LogIntoEPortal")
							{
								group("${aScriptReferencePrefix}_${NetworkType}_0020_P001_LogIntoEPortal_Primary"){
									exec(http("XXXXXXX")
										.post("${dynActionURL_PortalLogOn_2}")
										.formParam("username", "${PSYSTEMUSERNAMEN3}")
										.formParam("password", "${PSYSTEMUSERPASSWORDN3}")
										.formParam("login-form-type", "pwd")
										.disableFollowRedirect
										.check(status.is(302))
										.check(headerRegex("location",GlobalVariableConstants.baseUrl+"(.*)").find.saveAs("dynActionURL_PortalLogOn_3")))
								}
								.group("${aScriptReferencePrefix}_${NetworkType}_0020_R002_LogIntoEPortal_Redirection"){
									exec(http("XXXXXXXXX?nav=myE")
										.get("${dynActionURL_PortalLogOn_3}")
										.disableFollowRedirect
										.check(regex("""Login Failed""").find.notExists, status.in(200, 302), headerRegex("location",GlobalVariableConstants.baseUrl+"(.*)").find.optional.saveAs("dynActionURL_PortalLogOn_4")))
										.exitHereIfFailed
									.exec(session => {
										session.set("iEUserLoggedOn", "FALSE")
									})
								}
								.group("${aScriptReferencePrefix}_${NetworkType}_0020_R003_LogIntoEPortal_Redirection"){
									//exec(flushHttpCache)
									exec(http("Dashboard")
										.get("${dynActionURL_PortalLogOn_4}")
										
										.resources(http("JS_Req")
										.get("/dashboard/o/xxx-E-portal-XXXXXX/js/XXXXXXX.min.js")
										.header("Cache-Control","no-cache")
										.check(regex("""\{settings:\{portletName:"(\S+?)",rowTemplate""").findAll.optional.saveAs("dynPortletLongNameArray"))
										.check(regex("""\{settings:\{portletName:"(\S+?)",rowTemplate""").count.optional.saveAs("dynPortletLongNameArray_count"))
										.check(regex("""rowTemplate:"(\S+?)"\}""").findAll.optional.saveAs("dynPortletTemplateArray"))
										.check(regex("""(?:.settings.rowTemplate\);var e|,r)=Theme.getPathContext\("(\S+?)"\)""").findAll.optional.saveAs("dynPortletDelegateURLArray1")),
										http("Count")
										.post("XXXXXXXXXX/count"),
										http("UserPopUp")
										.get("XXXXXXXXX?_="+time)
										.check(regex("userId\":\"(.*?)\",").find.optional.saveAs("dynPopUpUser1"))
										)
										.check(regex("""portletId: 'xxxEG.*?_WAR_(.*?)',""").findAll.optional.saveAs("dynGPortletIDsArray"))
										.check(regex("""portletId: 'xxxEG.*?_WAR_(.*?)',""").count.saveAs("dynGPortletIDsArray_count"))
										.check(regex("""&resp_id=(.*?)&resp_appl_id=800&security_group_id=0&lang_code=US""").find.optional.saveAs("dynActionURL_RespID"))
										.check(status.is(200), regex("Dashboard - ").find, regex("""An Error Occured""").find.notExists))
										.exitHereIfFailed
									
								}
								
								.exec(session => {
										session.set("iEUserLoggedOn", "TRUE")
									})
							}
							/*.exec(session => {
								//println(session("dynPortletDelegateURLArray1").as[(String,String)]._2)
								println("GPORTLETTTTTTT" + session("dynGPortletIDsArray").as[String])
								println("LONGGGNAMEEEE" + session("dynPortletLongNameArray").as[String])
								println("TEMPLATEARRAYYYYYY" + session("dynPortletTemplateArray").as[String])
								session
							})*/
							
							
						.exec(session => 
						{
										val GPortletList = session("dynGPortletIDsArray").as[List[String]]
										val GPortletCount = session("dynGPortletIDsArray_count").as[Int]
										val PortletLongNameList = session("dynPortletLongNameArray").as[List[String]]
										val PortletLongNameCount = session("dynPortletLongNameArray_count").as[Int]
										val PortletTemplateList = session("dynPortletTemplateArray").as[List[String]]
										val PortletDelegateURLList = session("dynPortletDelegateURLArray1").as[List[String]]
										
										for( a <- 0 to GPortletCount-1)
										{
											GArrBuff += GPortletList(a).toString
											/*LongNameArrBuff += PortletLongNameList(a).toString
											TemplateArrBuff += PortletTemplateList(a).toString
											DelegateArrBuff += PortletDelegateURLList(a).toString*/					
										}
										for( b <- 0 to PortletLongNameCount-1)
										{
											
											LongNameArrBuff += PortletLongNameList(b).toString
											TemplateArrBuff += PortletTemplateList(b).toString
											DelegateArrBuff += PortletDelegateURLList(b).toString					
										}
						session
						})
						
						.exec(session =>{
										session.remove("dynGPortletIDsArray")	
												.remove("dynPortletLongNameArray")
												.remove("dynPortletTemplateArray")
												.remove("dynPortletDelegateURLArray1")
												
									})
					
					.exec(session =>
					{			
					for(j <- 0 to GArrBuff.size-1) 
					{
						
						pGPortletID = GArrBuff(j)
						for(k <- 0 to LongNameArrBuff.size-1) //yield k
						{
							sPortletLongName = LongNameArrBuff(k)
							pEditedPortletLongName = sPortletLongName.replace("-" , "")
							//println("WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW" + pEditedPortletLongName)
							breakable {
							if(pGPortletID == pEditedPortletLongName)
							{
								sPortletTemplate = TemplateArrBuff(k)
								sPortletDelegateURL1 = DelegateArrBuff(k)
								if(sPortletTemplate.matches(""".*personal.*""") && sPortletTemplate.matches(""".*handlebars""")) {
									req += "/dashboard"+sPortletDelegateURL1 + "?=" + time
									break
								}
								else if(sPortletDelegateURL1.matches(""".*upcomingTasks.*""")) {
									req += "/dashboard"+sPortletDelegateURL1 + "?count=0" + "&_=" + time
									break
								}
								else if(sPortletTemplate.matches(""".*equality.*""") && sPortletTemplate.matches(""".*handlebars""")) {
									req += "/dashboard"+sPortletDelegateURL1 + "?=" + time
									break
								}
								else{
									req1 += "/dashboard/o/" + sPortletLongName + "/js/templates/" + sPortletTemplate
									req += "/dashboard"+sPortletDelegateURL1 + "?=" + time
								}
							}
							}
							
						}
					}
						
						session.set("DelegateCalls", req.toList)
								.set("HandlebarCalls", req1.toList)
					})
						
						LongNameArrBuff.clear()
						TemplateArrBuff.clear()
						DelegateArrBuff.clear()
						GArrBuff.clear()
						req.clear()
						req1.clear()
						
							
	}
	
	object funEPortalManageDashboards
	{
		var time = System.currentTimeMillis()
		var PortletTxnStep = ""
		
		val funEPortalManageDashboards = 
			
			exec(session => {
				val CallAction = session("aCallingAction").as[String]
				if(CallAction == "DashboardLoad")
					PortletTxnStep = "0030_A001"
				else
					PortletTxnStep = "8020_A001"
			
				session.set("PortletTxnStep", PortletTxnStep)
			})
			
			.group("${aScriptReferencePrefix}_${NetworkType}_${PortletTxnStep}_E_${aCallingAction}_RenderPortlets_ConcurrentGroup"){ 
				exec(http("getUpcomingTasksCount")
				.get("XXXXXXX?_=" + time)
				.header("X-Requested-With","XMLHttpRequest")
				.header("Accept", "application/json, text/javascript, */*; q=0.01")
				.header("Upgrade-Insecure-Requests","1")
				.check(status.is(200), regex(""""count":(.*?),"""").find.saveAs("dynUpcomingTaskCount"))
				.resources(ReqDef.calc(6):_*)
				)
			}
			
			
			
			
			
	}	

	object ReqDef
	{
	
		def calc(si : Int) : Seq[HttpRequestBuilder] = { 
			var flag = "Y"
			var l = 0
			var LongBuff = ArrayBuffer[HttpRequestBuilder]()
				do{
					def s = generateDelegateRequest(l)
					def s1 = generateHandlebarRequest(l)
					 if(l < si){
						LongBuff += s
						LongBuff += s1
					 }
					else
						flag = "N"
					l = l+1
					}while(flag == "Y")
			
			var parallelRequests : Seq[HttpRequestBuilder] = LongBuff.toSeq
			LongBuff.clear()
				
		return parallelRequests
		}
				
			
		def generateDelegateRequest(id1: Int): HttpRequestBuilder = {
		
		
			//doIf(session => session("REQ").as[List[String]].apply(id1).matches(""".*handlebars""")){
				//http("Delegate"+id1)
				http("Portlet")
					.get(session => session("DelegateCalls").as[List[String]].apply(id1))
					.header("X-Requested-With","XMLHttpRequest")
					.header("Cache-Control","no-cache")
					.header("Accept", "application/json, text/javascript, */*; q=0.01")
					.check(status.is(200), regex("payslipDownloadUrl\":\""+GlobalVariableConstants.baseUrl+"/(.*?)\",").find.optional.saveAs("dynPayslipUrl"))
					
			}
		//}
		
		def generateHandlebarRequest(id2: Int): HttpRequestBuilder = {
			
			val headers_6 = Map(
				"Accept" -> "*/*",
				"sec-ch-ua-mobile" -> "?0",
				"X-Requested-With" -> "XMLHttpRequest",
				"Sec-Fetch-Dest" -> "empty",
				"Sec-Fetch-Mode" -> "cors",
				"Sec-Fetch-Site" -> "same-origin")							
			
				http("Portlet")
					.post(session => session("HandlebarCalls").as[List[String]].apply(id2))
					.headers(headers_6)
					.check(status.in(200, 304))
		}
		
	}
	
	object funEPortalLogOff{
		
		def randomFunc1() = Random.nextInt(100)
		
		val funEPortalLogOff = 
		
			doIfOrElse(session => {randomFunc1()} >= GlobalVariableConstants.APPLICATION_LOGOUT_EACH_ITERATION_PERCENTAGE){
				exec(session => {
					println("++++++++++++++++++++++++++++++++++++++Not logging out Employee type user this time")
				session	
				})
				//.exec(http("000_G_E_GEN_CountOfLogOutOfApplicationByPassed").get("http://localhost").check(status.is(404)))
					.exec(session => {
						println("The specified system user has NOT logged out of the E Application this time.")
						session.set("iEUserLoggedOn", "FALSE")
						session.set("iEFunctionOpen", "FALSE")	
				})	
			}
			{
				group("000_G_E_GEN_CountOfLogOutOfApplicationActioned"){
					group("${aScriptReferencePrefix}_${NetworkType}_9010_LogOutOfApplication"){
						group("${aScriptReferencePrefix}_${NetworkType}_9010_P001_LogOutOfApplication_Primary"){
							exec(http("c/portal/logout")
									.get("/dashboard/c/portal/logout")
									//.header("X-Requested-With", "XMLHttpRequest")
									.disableFollowRedirect
									.check(status.is(302), headerRegex("location",GlobalVariableConstants.baseUrl+"/(.*)").find.saveAs("dynActionURL_PortalLogOff_2"))
							)
						}
						.group("${aScriptReferencePrefix}_${NetworkType}_9010_R002_LogOutOfApplication_Redirection"){
							exec(http("Logout_Redirect")
								.get("/${dynActionURL_PortalLogOff_2}")
								.header("Accept","text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9")
								.check(regex("""Successfully logged out""").find)
							)
						}
						.exec(session => {
							println("Logged out Employee type user this time")
							session.set("iEUserLoggedOn", "FALSE")
							session.set("iEFunctionOpen", "FALSE")	
						})
					}
				}
			}
	
	}